var App =  {
	_frame:		 	 null,
	_language:		 "en",
	_messages: 		 {},
	_productManager: null,
	
	Initialize: function(userId, lang) {
		Settings.userId = userId;
		this._language = lang;
		this._productManager = new ProductManager();

		AndroidFullScreen.immersiveMode();

		this.CreateFrame(document.body, Settings.userId, this._language);
	},

	FrameCall: function(name, args) {
		var func = {name: "callFunction", functionName: name};
		if(args) {
			func.params = args;
		}

		this._frame.contentWindow.postMessage(func, "*");
	},

	OnInitialized: function() {
		document.addEventListener('backbutton', _.bind(this.OnBackButtonPress, this), false);
		window.addEventListener('message', _.bind(this.OnMessageReceive, this));
		
		window.framePostMessage = _.bind(this.FrameCall, this);
		
		this._frame.contentWindow.open = _.bind(cordova.InAppBrowser.open, this);
		
		this._frame.contentWindow.tryContactSupport = _.bind(function(){
			cordova.InAppBrowser.open('mailto:'+Settings.emailSupport, '_system');
		}, this);
		this._frame.contentWindow.tryRateGame = _.bind(function(){
			cordova.InAppBrowser.open('market://details?id=' + Settings.appId, '_system');
		}, this);

		this.ConfigureMessages();
		this._productManager.Initialize(Settings);
	},

	ConfigureMessages: function() {
		this._messages.successPurchase = _.bind(this._productManager.SuccessPurchase, this);
		this._messages.buy = _.bind(this._productManager.Purchase, this);
	},

	CreateFrame: function(parent, userId, lang) {
		this._frame = document.createElement("iframe");
		this._frame.id = "gameIframe";
		this._frame.frameborder = "0";
		this._frame.src = Settings.appLink + Settings.authQuery.replace(/{UUID}/g, userId).replace(/{LNG}/g, lang);
		this._frame.onload = _.bind(this.OnInitialized, this);

		parent.appendChild(this._frame);
	},
	
	OnBackButtonPress: function() {
		if (!this._frame) {
			return;
		}

		if (this._frame.contentWindow.onBackPress) {
			this._frame.contentWindow.onBackPress();
		}
	},

	OnMessageReceive: function(msg) {
		if(!_.has(this._messages, msg.data.name)) {
			return;
		}
		
		this._messages[msg.data.name].call(null, msg.data);
	},


	ReplaceLocaleToKnown: function (lcid) {
        lcid = lcid.toLowerCase();

        supportedLangs = ['en', 'ru'];
        
        var lang = replaceInternal(lcid);

        if (supportedLangs.indexOf(lang) != -1) {
            this._language = lang;
        } else {
            this._language = supportedLangs[0];
        }

    },
}